package jp.gmail.tdr;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Status;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class AgentInfo extends MybasePlayer {
	public GameInfo latestGameInfo;
	int readTalkNum;
	Map<Agent, Integer[]> infoMap = new HashMap<>();
	Map<Agent, Double> output = new HashMap<>();
	Map<Agent, Agent> votingMap;
	Set<Agent> SeerCOAg = new HashSet<Agent>();
	Set<Agent> MediumCOAg = new HashSet<Agent>();
	Set<Agent> BodyguardCOAg = new HashSet<Agent>();
	Set<Agent> PossessedCOAg = new HashSet<Agent>();
	List<Agent> SeerCO = new ArrayList<>();
	List<Agent> MediumCO = new ArrayList<>();
	List<Agent> BodyCO = new ArrayList<>();
	List<Agent> PossessedCO = new ArrayList<>();
	List<Agent> wolf = new ArrayList<>();
	List<Agent> human = new ArrayList<>();
	List<Agent> guardlist = new ArrayList<>();
	Map<Agent, Set<Agent>> wolfAgentMap = new HashMap<Agent, Set<Agent>>();
	Map<Agent, Set<Agent>> humanAgentMap = new HashMap<Agent, Set<Agent>>();
	Map<Agent, Set<Agent>> MwolfAgentMap = new HashMap<Agent, Set<Agent>>();
	Map<Agent, Set<Agent>> MhumanAgentMap = new HashMap<Agent, Set<Agent>>();
	Map<Agent, Integer> orderSeerCO = new HashMap<>();
	Map<Agent, Integer> orderMediumCO = new HashMap<>();
	Map<Agent, Status> AliveOrDeadMap = new HashMap<Agent, Status>();

	public void inintialize(GameInfo gameInfo, GameSetting gameSetting) {

		latestGameInfo = gameInfo;
		initDeadOrAlive();
		input();

	}

	private void initDeadOrAlive() {
		// TODO 自動生成されたメソッド・スタブ
		for (Agent agt : latestGameInfo.getAgentList()) {
			AliveOrDeadMap.put(agt, Status.ALIVE);
		}
	}

	@Override
	public void dayStart() {
		// TODO 自動生成されたメソッド・スタブ
		getInfo();

		setDeadOrAlive();
		readTalkNum = 0;
		votingMap = new HashMap<Agent, Agent>();
		for (Agent agt : latestGameInfo.getAliveAgentList()) {
			votingMap.put(agt, null);
		}
	}

	private void getInfo() {
		// TODO 自動生成されたメソッド・スタブ
		if (latestGameInfo.getDay() > 0) {
			for (Agent agent : latestGameInfo.getAgentList()) {
				Integer[] info = new Integer[21];
				info[10] = latestGameInfo.getDay() - 1;
				if (AliveOrDeadMap.get(agent) == Status.ALIVE) {
					info[0] = 1;
				} else {
					info[0] = 0;
				}
				info[1] = SeerCOAg.size();
				info[2] = MediumCOAg.size();
				info[3] = 0;
				info[4] = 0;
				info[11] = BodyguardCOAg.size();
				info[12] = PossessedCOAg.size();
				for (Agent seer : SeerCOAg) {
					if (humanAgentMap.get(seer).contains(agent)) {
						info[3]++;
					}
					if (wolfAgentMap.get(seer).contains(agent)) {
						info[4]++;
					}
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					if (AliveOrDeadMap.get(agent) == Status.ALIVE) {
						for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
							if (latestGameInfo.getVoteList().get(i).getAgent() == agent) {
								if (latestGameInfo.getVoteList().get(i)
										.getTarget() != votingMap.get(agent)) {
									info[9] = infoMap.get(agent)[9] + 1;
								} else {
									info[9] = infoMap.get(agent)[9];
								}
							}
						}
					} else {
						info[9] = infoMap.get(agent)[9];
					}
				} else {
					info[9] = 0;
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
						if (SeerCO.contains(latestGameInfo.getVoteList().get(i)
								.getTarget())) {
							info[13] = 1;
						} else {
							info[13] = 0;
						}
					}
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
						if (MediumCO.contains(latestGameInfo.getVoteList()
								.get(i).getTarget())) {
							info[14] = 1;
						} else {
							info[14] = 0;
						}
					}
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
						if (BodyCO.contains(latestGameInfo.getVoteList().get(i)
								.getTarget())) {
							info[15] = 1;
						} else {
							info[15] = 0;
						}
					}
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
						if (PossessedCO.contains(latestGameInfo.getVoteList()
								.get(i).getTarget())) {
							info[16] = 1;
						} else {
							info[16] = 0;
						}
					}
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
						if (wolf.contains(latestGameInfo.getVoteList().get(i)
								.getTarget())) {
							info[17] = 1;
						} else {
							info[17] = 0;
						}
					}
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
						if (human.contains(latestGameInfo.getVoteList().get(i)
								.getTarget())) {
							info[18] = 1;
						} else {
							info[18] = 0;
						}
					}
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
						if (guardlist.contains(latestGameInfo.getVoteList()
								.get(i).getTarget())) {
							info[19] = 1;
						} else {
							info[19] = 0;
						}
					}
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
						if (guardlist.contains(latestGameInfo.getVoteList()
								.get(i).getTarget())) {
							info[19] = 1;
						} else {
							info[19] = 0;
						}
					}
				}
				if (!latestGameInfo.getVoteList().isEmpty()) {
					for (int i = 0; i < latestGameInfo.getVoteList().size(); i++) {
						if (killedAgents.contains(latestGameInfo.getVoteList()
								.get(i).getTarget())) {
							info[20] = 1;
						} else {
							info[20] = 0;
						}
					}
				}
				info[5] = 0;
				info[6] = 0;
				info[7] = 0;
				info[8] = 0;
				if (SeerCOAg.contains(agent)) {
					info[5] = orderSeerCO.get(agent);
					info[7] = humanAgentMap.get(agent).size();
					info[8] = wolfAgentMap.get(agent).size();
				}
				if (MediumCOAg.contains(agent)) {
					info[6] = orderMediumCO.get(agent);
				}
				infoMap.put(agent, info);
			}
		}
	}

	private void input() {
		for (Agent agt : latestGameInfo.getAgentList()) {
			int in = 21;
			int[] inp = null;
			for (int i = 0; i < in; i++) {
				inp[i] = infoMap.get(agt)[i];
				output.put(agt, out);
			}
		}
	}

	private void setDeadOrAlive() {
		// TODO 自動生成されたメソッド・スタブ
		Agent excutedAgent = latestGameInfo.getExecutedAgent();
		if (excutedAgent != null) {
			AliveOrDeadMap.put(excutedAgent, Status.DEAD);
		}
		List<Agent> deadAgentList = latestGameInfo.getLastDeadAgentList();
		for (Agent agt : deadAgentList) {
			AliveOrDeadMap.put(agt, Status.DEAD);
		}
	}

	@Override
	public void update(GameInfo gameInfo) {
		latestGameInfo = gameInfo;
		List<Talk> talkList = latestGameInfo.getTalkList();
		setVote(talkList);
		setCO(talkList);
		setWolfHUmanMap(talkList);
		readTalkNum = talkList.size();
	}

	private void setWolfHUmanMap(List<Talk> talkList) {
		// TODO 自動生成されたメソッド・スタブ
		if (latestGameInfo.getDay() > 0
				&& latestGameInfo.getAliveAgentList().contains(
						latestGameInfo.getAgent())) {
			for (int i = readTalkNum; i < talkList.size(); i++) {
				Talk talk = talkList.get(i);
				Content content = new Content(talk.getText());
				Agent subject = talk.getAgent();
				Agent target = content.getTarget();
				Species species = content.getResult();
				if (content.getTopic() == Topic.DIVINED) {
					if (species == Species.WEREWOLF) {
						Set<Agent> wolfAgent = wolfAgentMap.get(subject);
						wolfAgent.add(target);
						wolf.add(target);
						wolfAgentMap.put(subject, wolfAgent);
					} else if (species == Species.HUMAN) {
						Set<Agent> humanAgent = humanAgentMap.get(subject);
						humanAgent.add(target);
						human.add(target);
						humanAgentMap.put(subject, humanAgent);
					}
				} else if (content.getTopic() == Topic.IDENTIFIED) {
					if (species == Species.WEREWOLF) {
						Set<Agent> wolfAgent = MwolfAgentMap.get(subject);
						wolfAgent.add(target);
						MwolfAgentMap.put(subject, wolfAgent);
					} else if (species == Species.HUMAN) {
						Set<Agent> humanAgent = MhumanAgentMap.get(subject);
						humanAgent.add(target);
						MhumanAgentMap.put(subject, humanAgent);
					}
				}
			}
		}
	};

	private void setCO(List<Talk> talkList) {
		// TODO 自動生成されたメソッド・スタブ
		if (latestGameInfo.getAliveAgentList().contains(
				latestGameInfo.getAgent())) {
			for (int i = readTalkNum; i < talkList.size(); i++) {
				Talk talk = talkList.get(i);
				Content content = new Content(talk.getText());
				Agent subject = talk.getAgent();
				Agent target = content.getTarget();
				Role COrole = content.getRole();
				Set<Agent> wolf = new HashSet<Agent>();
				Set<Agent> human = new HashSet<Agent>();
				switch (content.getTopic()) {
				case COMINGOUT:
					if (target == subject) {
						switch (COrole) {
						case SEER:
							SeerCOAg.add(target);
							SeerCO.add(target);
							wolfAgentMap.put(subject, wolf);
							humanAgentMap.put(subject, human);
							orderSeerCO.put(subject, SeerCOAg.size());
							break;
						case MEDIUM:
							MediumCOAg.add(target);
							MediumCO.add(target);
							MwolfAgentMap.put(subject, wolf);
							MhumanAgentMap.put(subject, human);
							orderMediumCO.put(subject, MediumCOAg.size());
							break;
						case BODYGUARD:
							BodyguardCOAg.add(target);
							BodyCO.add(target);
							break;
						case FOX:
							break;
						case FREEMASON:
							break;
						case POSSESSED:
							PossessedCO.add(target);
							PossessedCOAg.add(target);
							break;
						case VILLAGER:
							break;
						case WEREWOLF:
							break;
						default:
							break;
						}
					}
					break;

				case DIVINED:
					SeerCOAg.add(subject);
					humanAgentMap.put(subject, human);
					wolfAgentMap.put(subject, wolf);
					break;

				case IDENTIFIED:
					MediumCOAg.add(subject);
					MhumanAgentMap.put(subject, human);
					MwolfAgentMap.put(subject, wolf);
					MwolfAgentMap.put(subject, wolf);
					break;
				case AGREE:
					break;
				case ATTACK:
					break;
				case DISAGREE:
					break;
				case DIVINATION:
					break;
				case ESTIMATE:
					break;
				case GUARD:
					break;
				case GUARDED:
					guardlist.add(target);
					break;
				case OPERATOR:
					break;
				case OVER:
					break;
				case SKIP:
					break;
				case VOTE:
					break;
				default:
					break;

				}
			}
		}
	}

	private void setVote(List<Talk> talkList) {
		// TODO 自動生成されたメソッド・スタブ
		if (latestGameInfo.getAliveAgentList().contains(
				latestGameInfo.getAgent())) {
			for (int i = readTalkNum; i < talkList.size(); i++) {
				Talk talk = talkList.get(i);
				Content content = new Content(talk.getText());
				Agent subject = talk.getAgent();
				Agent target = content.getTarget();
				if (content.getTopic() == Topic.VOTE) {
					if (latestGameInfo.getAliveAgentList().contains(target)) {
						votingMap.put(subject, target);
					}
				}
			}
		}
	}

}
