package jp.gmail.tdr;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

public class Mybodygurad extends Myvillager {
	Agent guardedAgent;

	@Override
	public void initialize(GameInfo gameInfo, GameSetting gameSetting) {
		super.initialize(gameInfo, gameSetting);
		guardedAgent = null;
	}

	@Override
	public Agent guard() {
		Agent guardCandidate = null;

		if (guardedAgent != null && isAlive(guardedAgent)
				&& currentGameInfo.getLastDeadAgentList().isEmpty()) {
			guardCandidate = guardedAgent;
		}

		else {

			List<Agent> candidates = new ArrayList<>();
			for (Agent agent : aliveOthers) {
				if (comingoutMap.get(agent) == Role.SEER
						&& !werewolves.contains(agent)) {
					candidates.add(agent);
				}
			}

			if (candidates.isEmpty()) {
				for (Agent agent : aliveOthers) {
					if (comingoutMap.get(agent) == Role.MEDIUM
							&& !werewolves.contains(agent)) {
						candidates.add(agent);
					}
				}
			}

			if (candidates.isEmpty()) {
				for (Agent agent : aliveOthers) {
					if (!werewolves.contains(agent)) {
						candidates.add(agent);
					}
				}
			}

			if (candidates.isEmpty()) {
				candidates.addAll(aliveOthers);
			}

			guardCandidate = randomSelect(candidates);
		}
		guardedAgent = guardCandidate;
		return guardCandidate;
	}
}
